/**
 * License Agreement.
 *
 * Rich Faces - Natural Ajax for Java Server Faces (JSF)
 *
 * Copyright (C) 2007 Exadel, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

package org.ajax4jsf.portlet.lifecycle;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import javax.faces.lifecycle.Lifecycle;
import javax.faces.lifecycle.LifecycleFactory;

/**
 * @author shura (latest modification by $Author: alexsmirnov $)
 * @version $Revision: 1.1.2.1 $ $Date: 2007/01/09 18:57:12 $
 *
 */
public class PortletLifecycleFactory extends LifecycleFactory {
	
	private LifecycleFactory _defaultFactory;
	
	//Map<String, Lifecycle>
	private final Map _lifecycles = new HashMap(1);
	
//	private Map _lifecycles = new HashMap();


	/**
	 * @param defaultFactory
	 */
	public PortletLifecycleFactory(LifecycleFactory defaultFactory) {
		super();
		this._defaultFactory = defaultFactory;
		this._lifecycles.put(DEFAULT_LIFECYCLE, new PortletLifecycle());
	}

	/* (non-Javadoc)
	 * @see javax.faces.lifecycle.LifecycleFactory#addLifecycle(java.lang.String, javax.faces.lifecycle.Lifecycle)
	 */
	public void addLifecycle(String lifecycleId, Lifecycle lifecycle) {
		if(null == lifecycleId || null == lifecycle){
			throw new NullPointerException("arguments for a addLifecycle method can't be null");
		}
		_lifecycles.put(lifecycleId, lifecycle);
	}

	/* (non-Javadoc)
	 * @see javax.faces.lifecycle.LifecycleFactory#getLifecycle(java.lang.String)
	 */
	public Lifecycle getLifecycle(String lifecycleId) {
		if(null == lifecycleId ){
			throw new NullPointerException("argument for a removeLifecycle method can't be null");
		}
		return (Lifecycle) _lifecycles.get(lifecycleId);
	}

	/* (non-Javadoc)
	 * @see javax.faces.lifecycle.LifecycleFactory#getLifecycleIds()
	 */
	public Iterator getLifecycleIds() {
		return _lifecycles.keySet().iterator();
	}

}
